#ifndef HELPFILE_H
#define HELPFILE_H

const char helpfile_msg[] = 

"\n"
"Sending faxes\n"
"-------------\n"
"\n"
"Before sending a fax, the name of the file to be sent must be\n"
"specified in the \"File to fax\" box.  The file specified must be in\n"
"postscript format, and will be converted by the program into the\n"
"correct tiffg3 fax format.\n"
"\n"
"The file can be entered into the \"File to fax\" box by pressing the\n"
"\"File to fax\" button (or from the `File/Find file' pull down menu\n"
"item), by starting the program with the filename as the last parameter,\n"
"or by entering it by hand into the box.  Files can be more easily\n"
"found with the Find file dialog if they are placed in the $HOME/faxout\n"
"directory.\n"
"\n"
"In addition, the telephone number to which the fax is to be sent must\n"
"be entered into the \"Tel number\" box.  This can be entered directly\n"
"into the box, or by using the built-in addressbook.  The addressbook\n"
"can be invoked by pressing the \"Tel number\" button, or from the\n"
"`File/Address book' pull-down menu item.  See \"Using the address book\"\n"
"further below.\n"
"\n"
"To make the sending of faxes direct from a word processor program more\n"
"easy, see the README file which comes with the distribution.\n"
"\n"
"Successfully sent faxes are copied to a directory in the $HOME/faxsent\n"
"directory, which has a name derived from the year, month, day, hour\n"
"and seconds when the sending of the fax was completed, and will appear\n"
"in the faxes sent list.  They are only included in that list if they\n"
"have been sent without error.  The efax message display box will\n"
"report on the progress of a fax being sent.  The fax list can be\n"
"brought up from the `File/List sent faxes' pull down menu item.  See\n"
"\"Using the fax lists\" further below.\n"
"\n"
"Receiving faxes\n"
"---------------\n"
"\n"
"Three ways of receiving faxes are provided for.\n"
"\n"
"First, the program can be set to answer a fax call which is ringing\n"
"but has not been answered, by pressing the \"Answer call\" button.\n"
"\n"
"Secondly, the program can take over a call which has already been\n"
"answered (say, by a telephone hand set) by pressing the \"Take over\n"
"call\" button.\n"
"\n"
"Thirdly, the program can be placed in standby mode by pressing the\n"
"\"Standby\" button.  This will automatically answer any call after the\n"
"number of rings specified in the efax-gtkrc file, and receive the fax.\n"
"The program will keep on receiving faxes until the \"Stop\" button is\n"
"pressed.\n"
"\n"
"Received faxes in tiffg3 format (one file for each page) are placed in\n"
"a directory in the $HOME/faxin directory, which has a name derived\n"
"from the year, month, day, hour and seconds when the relevant \"Answer\n"
"call\", \"Take over call\" or \"Standy\" button was pressed.  (Where in\n"
"standby mode after a fax has been received, any further fax will\n"
"derive its name from the time when receipt of the last received fax\n"
"has been completed and the program goes back into standby mode.)\n"
"\n"
"Received faxes can be printed, viewed, described and managed using the\n"
"built in fax list facility.  This can be brought up from the\n"
"`File/List received faxes' pull down menu item.  See \"Using the fax\n"
"lists\" further below.\n"
"\n"
"Using the address book\n"
"----------------------\n"
"\n"
"To pick a telephone number from the address book, highlight the\n"
"relevant address by pressing the left mouse button over it, and then\n"
"press the \"OK\" button.\n"
"\n"
"Addresses can be added to the address book by pressing the add button,\n"
"and then completing the relevant dialog which will appear.  To delete\n"
"an address from the address book, highlight the relevant address and\n"
"press the delete (trashcan) button.  The addressbook can be sorted by\n"
"using the up and down arrow buttons on a highlighted address.\n"
"\n"
"Using the fax lists\n"
"------------------\n"
"\n"
"To bring up the fax lists, go to the the `File' menu and pick the\n"
"`List received faxes' or `List sent faxes' menu item.  Highlight the\n"
"fax to printed or viewed by pressing the left mouse button.  The\n"
"programs to be used to print and view the fax are specifed in the\n"
"efax-gtkrc configuration file, or if none are specified, the program\n"
"will print using lpr (which will work for most Unix systems) and view\n"
"with xloadimage.\n"
"\n"
"Prepend `$' to the program name in the efax-gtkrc file for viewing the\n"
"fax if the fax viewing program can take multiple file names as its\n"
"starting arguments, in which case all the pages of the fax to be\n"
"viewed will be passed as file names to the viewing program when first\n"
"invoked (eg `$kview' will use the KDE image viewer) -- see the\n"
"efax-gtkrc configuration file for further details.  Alternatively this\n"
"can be set from the `Settings' dialog by entering it in the\n"
"`View/View' Program box.\n"
"\n"
"The resolution of the fax to be viewed is specified with the VIEW_RES\n"
"parameter in the efax-gtkrc file.  The default is 200 dpi, which will\n"
"be fine with xloadimage or xv, but with a fax viewing program like\n"
"kview, 400 would give better results.  This can be changed while the\n"
"program is running by bringing up the `Settings' dialog and entering\n"
"it into the `View/View Resolution' box.\n"
"\n"
"To print faxes, a PRINT_SHRINK parameter can be specifed in efax-gtkrc\n"
"to enable the fax page to fit within the printer margins.  A parameter\n"
"of 98 will work with most printers.  This can be changed while the\n"
"program is running by bringing up the `Settings' dialog and entering\n"
"it into the `Print/Print Shrink' box.\n"
"\n"
"A fax can be deleted from a fax list by pressing the delete (trashcan)\n"
"button.  This will place the deleted fax in the $HOME/faxin/oldfax\n"
"or $HOME/faxsent/oldfax directory.\n"
"\n"
"NB: link()/unlink() are used to move a fax, so $HOME/faxin/oldfax must\n"
"be on the same file system as $HOME/faxin, and $HOME/faxsent/oldfax\n"
"must be on the same file system as $HOME/faxsent.  If they are not,\n"
"the fax will remain in $HOME/faxin or $HOME/faxsent.\n"
"\n"
"A description can be added to a received fax when appearing in a fax\n"
"list (or subsequently amended) by pressing the relevant button -- this\n"
"will enable faxes to be more easily identified.\n"
"\n"
"To refresh a fax list (say, to update with any faxes received or sent\n"
"since the fax list was brought up), press the refresh button.\n"
"\n"
"Settings\n"
"--------\n"
"\n"
"The program settings can be changed by manually editing the efax-gtk\n"
"configuration file comprising $HOME/.efax-gtkrc,\n"
"/usr/local/etc/efax-gtkrc or /etc/efax-gtkrc.  The file is searched\n"
"for in that order, so $HOME/.efax-gtkrc takes precedence over the\n"
"other two.\n"
"\n"
"The configuration file can also be set by using the Settings dialog\n"
"launched from the `File/Settings' pull down menu item.  The settings\n"
"entered using this dialog are always stored as $HOME/.efax-gtkrc.\n"
"Accordingly, if the Settings dialog has been used, and you want to\n"
"revert to the global settings, this can be done either by deleting the\n"
"$HOME/.efax-gtkrc file, or by pressing the `Reset' button in the\n"
"Settings dialog, which will reload the Settings dialog from\n"
"/etc/efax-gtkrc or /usr/local/etc/efax-gtkrc.\n"
"\n"
"Help can be obtained when filling out the Settings dialog by holding\n"
"the mouse over the relevant help (?) button, which will bring up a\n"
"\"Tips\" display, or by pressing the button, which will bring up an\n"
"information display.\n"


;

#endif


